# Part of UPE


def pkgin(*pkglist):
    import json
    from upe import config
    with open(config.packages.database, 'r') as f:
        db = json.load(f)
    found = True
    missing = []
    for pkg in pkglist:
        if pkg in db:
            found = found and True
        else:
            found = found and False
            missing.append(pkg)
    if found is True:
        return (True,)
    else:
        return (False, missing)


def getver(pkg):
    import json
    from upe import config
    with open(config.packages.database, 'r') as f:
        db = json.load(f)
    return [int(db[pkg]['version']), float(db[pkg]['release']),
        int(db[pkg]['pkgrel'])]


def checkneeded(pkg, ignore=[]):
    import json
    from upe import config
    with open(config.pachages.database, 'r') as f:
        db = json.load(f)
    requiring = []
    for package in db:
        if package in ignore:
            continue
        for dep in db[package]['deps']:
            if dep == pkg:
                requiring.append(dep)
    if len(requiring) > 0:
        return (True, tuple(requiring))
    else:
        return (False,)


# Deprecated parts:

#class vercompare:
    #def __init__(self, version1):
        #self.version1 = version1

    #def major(self, version2):
        #version1 = self.version1
        #if version1[0] > version2[0]:
            #if version1[1] > version2[1]:
                #if version1[2] > version2[2]:
                    #return True
                #else:
                    #return False
            #else:
                #return False
        #else:
            #return False

    #def majorequal(self, version2):
        #version1 = self.version1
        #if version1[0] >= version2[0]:
            #if version1[1] >= version2[1]:
                #if version1[2] >= version2[2]:
                    #return True
                #else:
                    #return False
            #else:
                #return False
        #else:
            #return False

    #def equal(self, version2):
        #version1 = self.version1
        #if version1[0] == version2[0]:
            #if version1[1] == version2[1]:
                #if version1[2] == version2[2]:
                    #return True
                #else:
                    #return False
            #else:
                #return False
        #else:
            #return False

    #def minorequal(self, version2):
        #version1 = self.version1
        #if version1[0] <= version2[0]:
            #if version1[1] <= version2[1]:
                #if version1[2] <= version2[2]:
                    #return True
                #else:
                    #return False
            #else:
                #return False
        #else:
            #return False

    #def minor(self, version2):
        #version1 = self.version1
        #if version1[0] < version2[0]:
            #if version1[1] < version2[1]:
                #if version1[2] < version2[2]:
                    #return True
                #else:
                    #return False
            #else:
                #return False
        #else:
            #return False

    #def notequal(self, version2):
        #version1 = self.version1
        #if version1[0] != version2[0]:
            #if version1[1] != version2[1]:
                #if version1[2] != version2[2]:
                    #return True
                #else:
                    #return False
            #else:
                #return False
        #else:
            #return False